<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">
<xsl:output method="html" omit-xml-declaration="no" indent="yes"/>


<xsl:param name="selected_packet" select="'1'"/>

<!-- This stylesheet does not work when the capture was generated after copying/cutting elements, because -->
<!-- the value in the PSML file does not match the position in the PDML file. -->

<xsl:template match="/">
	<html>
		<head>
			<link rel="stylesheet" type="text/css" href="capture-css.css"/> 
		</head>
		<body>
			<table border="1">
				<xsl:apply-templates/>
			</table>
		</body>
	</html>
</xsl:template>


<xsl:template match="structure">
	<tr>
		<xsl:for-each select="section">
			<th>
				<xsl:value-of select="." />
			</th>
		</xsl:for-each>
	</tr>
</xsl:template>


<xsl:template match="packet">

	<!-- Save the position of the current packet into the 'num' variable -->
	<xsl:variable name="num" select="section" />

	<xsl:choose>

		<xsl:when test="section= $selected_packet">

			<tr class="IndexSelected">

				<xsl:for-each select="section">
					<td> 
	
						<xsl:if test="position()=1">
							<img src="pktindex.png"/>
						</xsl:if>
	
						<xsl:value-of select="."/>
					</td>
				</xsl:for-each>
			</tr>
		</xsl:when>

		<xsl:otherwise>

			<tr onClick="RefreshViews({$num})">

				<xsl:for-each select="section">
					<td>
<!--
	This code should print a 'no break space' in all the cells
	However, it does not work in IE6, while it works perfectly well in Xalan.
	No idea why
-->
<!--
					    <xsl:text disable-output-escaping="yes">&amp;nbps;</xsl:text>
-->
						<xsl:if test="position()=1">
							<img src="pktindex.png"/>
						</xsl:if>

						<xsl:value-of select="."/>
					</td>
				</xsl:for-each>
			</tr>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>


</xsl:stylesheet>
