<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">
<xsl:output method="html" omit-xml-declaration="no" indent="yes"/>


<xsl:param name="selected_packet" select="'1'"/>

<xsl:template match="pdml">
	<xsl:apply-templates select="packet[position()=$selected_packet]"/>
</xsl:template>


<xsl:template match="packet">
    <div class="directory">
		<p class="TreeProto"><img src="packet.png"/> Packet</p>
		<div style="display: block;">

		<xsl:apply-templates select="proto"/>
		</div>
	</div>
</xsl:template>


<xsl:template match="proto">

	<p class="TreeProto" onclick="LightField(getAttributeNode('numPac').value, getAttributeNode('from').value, getAttributeNode('numbytes').value)" numPac="{$selected_packet}" from="{@pos}" numbytes="{@size}">
		<img src="plus.png" alt="o" width="16" height="22" onclick="toggleFolder('A_{field/@name}', this)"/>
		<img src="folderclosed.png" alt="+" width="24" height="22" onclick="toggleFolder('A_{field/@name}', this)"/>
		<xsl:value-of select="@showname"/>
		[<xsl:value-of select="@pos"/> - <xsl:value-of select="@pos+@size"/>]
	</p>


	<div id="A_{field/@name}">

		<!-- Scans all following fields -->
		<xsl:for-each select="field">

			<xsl:choose>
				<!-- Executes this branch when element has children (it's a subfolder) -->
				<xsl:when test="count(field)!=0">
				
					<p class="TreeField" onclick="LightField(getAttributeNode('numPac').value, getAttributeNode('from').value, getAttributeNode('numbytes').value)" numPac="{$selected_packet}" from="{@pos}" numbytes="{@size}">
						<img src="blank.png" alt=" " width="16" height="22"/>
						<img src="plus.png" alt="\" width="16" height="22" onclick="toggleFolder('B_{@name}', this)"/>
						<img src="folderclosed.png" alt="+" width="24" height="22" onclick="toggleFolder('B_{@name}', this)"/>
						<xsl:value-of select="@showname"/>
					</p>

		
					<div id="B_{@name}">

						<xsl:for-each select="field">
							<xsl:choose>
	
								<!-- Executes this branch when element has children (it's a subfolder) -->
								<xsl:when test="count(field)!=0">
							
									<p class="TreeField" onclick="LightField(getAttributeNode('numPac').value, getAttributeNode('from').value, getAttributeNode('numbytes').value)" numPac="{$selected_packet}" from="{@pos}" numbytes="{@size}">
										<img src="blank.png" alt=" " width="16" height="22"/>
										<img src="blank.png" alt=" " width="16" height="22"/>
										<img src="plus.png" alt="\" width="16" height="22" onclick="toggleFolder('C_{@name}', this)"/>
										<img src="folderclosed.png" alt="+" width="24" height="22" onclick="toggleFolder('C_{@name}', this)"/>
										<xsl:value-of select="@showname"/>
									</p>


									<div id="C_{@name}">

										<!-- Scans all following fields -->
										<xsl:for-each select="field">

											<xsl:choose>

												<!-- Executes this branch when element has children (it's a subfolder) -->
												<xsl:when test="count(field)!=0">
											
													<p class="TreeField" onclick="LightField(getAttributeNode('numPac').value, getAttributeNode('from').value, getAttributeNode('numbytes').value)" numPac="{$selected_packet}" from="{@pos}" numbytes="{@size}">
														<img src="blank.png" alt=" " width="16" height="22"/>
														<img src="blank.png" alt=" " width="16" height="22"/>
														<img src="blank.png" alt=" " width="16" height="22"/>
														<img src="plus.png" alt="\" width="16" height="22" onclick="toggleFolder('D_{@name}_{@pos}', this)"/>
														<img src="folderclosed.png" alt="+" width="24" height="22" onclick="toggleFolder('D_{@name}_{@pos}', this)"/>
														<xsl:value-of select="@showname"/>
													</p>
											
													<div id="D_{@name}_{@pos}">

														<!-- Scans all following fields -->
														<xsl:for-each select="field">

															<xsl:choose>

																<!-- Executes this branch when element has children (it's a subfolder) -->
																<xsl:when test="count(field)!=0">
															
																	<p class="TreeField" onclick="LightField(getAttributeNode('numPac').value, getAttributeNode('from').value, getAttributeNode('numbytes').value)" numPac="{$selected_packet}" from="{@pos}" numbytes="{@size}">
																		<img src="blank.png" alt=" " width="16" height="22"/>
																		<img src="blank.png" alt=" " width="16" height="22"/>
																		<img src="blank.png" alt=" " width="16" height="22"/>
																		<img src="blank.png" alt=" " width="16" height="22"/>
																		<img src="plus.png" alt="\" width="16" height="22" onclick="toggleFolder('E_{@name}_{@pos}', this)"/>
																		<img src="folderclosed.png" alt="+" width="24" height="22" onclick="toggleFolder('E_{@name}_{@pos}', this)"/>
																		<xsl:value-of select="@showname"/>
																	</p>
															
																	<!-- Now, let's print all the fields present at this level -->
																	<div id="E_{@name}_{@pos}">
																		<xsl:for-each select="field">

																			<p class="TreeField" onclick="LightField(getAttributeNode('numPac').value, getAttributeNode('from').value, getAttributeNode('numbytes').value)" numPac="{$selected_packet}" from="{@pos}" numbytes="{@size}">
																				<img src="blank.png" alt=" " width="16" height="22"/>
																				<img src="blank.png" alt=" " width="16" height="22"/>
																				<img src="blank.png" alt=" " width="16" height="22"/>
																				<img src="blank.png" alt=" " width="16" height="22"/>
																				<img src="blank.png" alt=" " width="16" height="22"/>
																				<img src="blank.png" alt=" " width="16" height="22"/>
																				<img src="doc.png" alt="*" width="24" height="22" />
																				<xsl:value-of select="@showname"/>
																	
																				<!-- Call the standard template formatter for the field -->
																				<xsl:call-template name="FormatField"/>
																			</p>

																		</xsl:for-each>
																	</div>
																</xsl:when>
															
																<!-- Executes this branch when element has no children -->
																<xsl:otherwise>
																	<p class="TreeField" onclick="LightField(getAttributeNode('numPac').value, getAttributeNode('from').value, getAttributeNode('numbytes').value)" numPac="{$selected_packet}" from="{@pos}" numbytes="{@size}">
																		<img src="blank.png" alt=" " width="16" height="22"/>
																		<img src="blank.png" alt=" " width="16" height="22"/>
																		<img src="blank.png" alt=" " width="16" height="22"/>
																		<img src="blank.png" alt=" " width="16" height="22"/>
																		<img src="blank.png" alt=" " width="16" height="22"/>
																		<img src="doc.png" alt="*" width="24" height="22" />
																		<xsl:value-of select="@showname"/>
										
																		<!-- Call the standard template formatter for the field -->
																		<xsl:call-template name="FormatField"/>
																	</p>
																</xsl:otherwise>
															</xsl:choose>
									
														</xsl:for-each>
													</div>
												</xsl:when>
							
												<!-- Executes this branch when element has no children -->
												<xsl:otherwise>
													<p class="TreeField" onclick="LightField(getAttributeNode('numPac').value, getAttributeNode('from').value, getAttributeNode('numbytes').value)" numPac="{$selected_packet}" from="{@pos}" numbytes="{@size}">
														<img src="blank.png" alt=" " width="16" height="22"/>
														<img src="blank.png" alt=" " width="16" height="22"/>
														<img src="blank.png" alt=" " width="16" height="22"/>
														<img src="blank.png" alt=" " width="16" height="22"/>
														<img src="doc.png" alt="*" width="24" height="22" />
														<xsl:value-of select="@showname"/>
						
														<!-- Call the standard template formatter for the field -->
														<xsl:call-template name="FormatField"/>
													</p>
												</xsl:otherwise>
											</xsl:choose>
	
										</xsl:for-each>
									</div>
								</xsl:when>
				
								<!-- Executes this branch when element has no children -->
								<xsl:otherwise>

									<p class="TreeField" onclick="LightField(getAttributeNode('numPac').value, getAttributeNode('from').value, getAttributeNode('numbytes').value)" numPac="{$selected_packet}" from="{@pos}" numbytes="{@size}">
										<img src="blank.png" alt=" " width="16" height="22"/>
										<img src="blank.png" alt=" " width="16" height="22"/>
										<img src="blank.png" alt=" " width="16" height="22"/>
										<img src="doc.png" alt="*" width="24" height="22" />
										<xsl:value-of select="@showname"/>

										<!-- Call the standard template formatter for the field -->
										<xsl:call-template name="FormatField"/>
									</p>

								</xsl:otherwise>
							</xsl:choose>
					
						</xsl:for-each>
					</div>
	
				</xsl:when>

				<!-- Executes this branch when element has no children -->
				<xsl:otherwise>

					<p class="TreeField" onclick="LightField(getAttributeNode('numPac').value, getAttributeNode('from').value, getAttributeNode('numbytes').value)" numPac="{$selected_packet}" from="{@pos}" numbytes="{@size}">
						<img src="blank.png" alt=" " width="16" height="22"/>
						<img src="blank.png" alt=" " width="16" height="22"/>
						<img src="doc.png" alt="*" width="24" height="22" />
						<xsl:value-of select="@showname"/>

						<!-- Call the standard template formatter for the field -->
						<xsl:call-template name="FormatField"/>
					</p>

				</xsl:otherwise>
			</xsl:choose>

		</xsl:for-each>
	</div>

</xsl:template>


<xsl:template name="FormatField">

	<xsl:text> = </xsl:text>

	<xsl:choose>

		<!-- Executes this branch in case no 'showdtl' attribute exists -->
		<xsl:when test="count(@showdtl)=0">

			<!-- Print only if the 'print' attribute exists -->
			<xsl:if test="count(@show)!=0">
				<xsl:value-of select="@show"/>

				<!-- Print only if the 'showmap' attribute exists -->
				<xsl:if test="count(@showmap)!=0">
					<xsl:text> (</xsl:text>
					<xsl:value-of select="@showmap"/>
					<xsl:text>)</xsl:text>
				</xsl:if>
			</xsl:if>
		</xsl:when>

		<!-- Executes this branch in case the 'showdtl' attribute exists -->
		<xsl:otherwise>
			<xsl:value-of select="@showdtl"/>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>


</xsl:stylesheet>
